SystemOrganization addCategory: #ConfigurationOfMooseAlgos!

Object subclass: #ConfigurationOfMooseAlgos
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfMooseAlgos'!

!ConfigurationOfMooseAlgos class methodsFor: 'private' stamp: 'simon.denier 11/20/2009 17:16'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfMooseAlgos class methodsFor: 'private' stamp: 'simon.denier 11/20/2009 17:16'!
ensureMetacello
	"Minimum package versions from which to boot Metacello. Corresponds to version 1.0-beta.4"

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Minimum version of Gofer from which to bootstrap"
			self bootstrapPackage: 'Gofer-lr.67' from: 'http://source.lukas-renggli.ch/flair' ].
		Smalltalk at: #Gofer ifPresent: [:gofer |
			gofer new
				url: 'http://seaside.gemstone.com/ss/metacello';
				addVersion: 'Metacello-Core-dkh.273'; "Minimum version from which to bootstrap Metacello"
				addVersion: 'Metacello-MC-dkh.205'; "Minimum version from which to bootstrap Metacello"
				addPackage: 'Metacello-Configuration'; "Loads latest version of configuration package"
				load ].
		"load latest version of Metacello, load a specific version if desired"
		((Smalltalk at: #MetacelloConfiguration) project latestVersion) load: 'UI' ]! !

!ConfigurationOfMooseAlgos class methodsFor: 'metacello tool support' stamp: 'simon.denier 11/20/2009 17:16'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMooseAlgos class methodsFor: 'loading' stamp: 'simon.denier 11/20/2009 17:16'!
loadDefault
	(self project version: 'default') load! !

!ConfigurationOfMooseAlgos class methodsFor: 'accessing' stamp: 'simon.denier 11/20/2009 17:16'!
project

	^self new project! !

!ConfigurationOfMooseAlgos methodsFor: 'baselines' stamp: 'tg 11/21/2009 22:10'!
default: spec 
	<version: 'default'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/MooseAlgos'.
		spec 
			package: 'Moose-Algos-Graph' ;
			package: 'Moose-Tests-Algos-Graph' ;
			package: 'Moose-Algos-Clustering' ;
			package: 'Moose-Algos-LinearAlgebra'.
		spec group: 'Tests' with: #(
						'Moose-Tests-Algos-Graph'
						"Dangerous now: Clustering and LinearAlgebra tests chrash the VM"). 
		spec
			project: 'Mondrian for MooseAlgos' with: [
				spec
					className: 'ConfigurationOfMondrian';
					file: 'ConfigurationOfMondrian';
					version: 'default';
					repository: 'http://www.squeaksource.com/Mondrian' ].
	]! !

!ConfigurationOfMooseAlgos methodsFor: 'accessing' stamp: 'simon.denier 11/20/2009 17:16'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project]! !
